﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace WSCF.Test.Server
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        WSCF.Test.Server.WsProxy.WsProxy wsProxy;
        Foo foo;

        DispatcherTimer timer;
        ObservableCollection<DateTime> SessionStartTimes = new ObservableCollection<DateTime>();

        public MainWindow()
        {
            InitializeComponent();
            foo = new Foo();
            
            wsProxy = new WsProxy.WsProxy("127.0.0.1:5540",foo);

            this.DataContext = foo;

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Tick += Timer_Tick;
            timer.Start();

            lst.ItemsSource = SessionStartTimes;
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            if (wsProxy.wssv.WebSocketServices.Hosts.Count() > 0)
            {
                var startimes = wsProxy.wssv.WebSocketServices.Hosts.First().Sessions.Sessions.Select(s => s.StartTime);
                for (int i = 0; i < startimes.Count(); i++)
                {
                    var startime = startimes.ElementAt(i);
                    if (i < SessionStartTimes.Count)
                    {
                        SessionStartTimes[i] = startime;
                    }
                    else
                    {
                        SessionStartTimes.Add(startime);
                    }
                }
                while (SessionStartTimes.Count() > startimes.Count())
                    SessionStartTimes.RemoveAt(SessionStartTimes.Count() - 1);
            }
        }
    }
}
